package com.javahonk;

import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.AbstractApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.javahonk.dao.StoredProcedureDao;
import com.javahonk.model.TestModelForProcedure;
import com.javahonk.model.TestModelWithoutColumnMapping;

public class HibernateStoreProcedureApp {

	private static final Logger logger = LogManager.getLogger(HibernateStoreProcedureApp.class.getName());

	@SuppressWarnings({ "unchecked" })
	public static void main(String[] args) {

		logger.info("Starting HibernateStoreProcedureApp...");

		ApplicationContext context = new ClassPathXmlApplicationContext("spring-context.xml");

		StoredProcedureDao<?> storeProcedureDao = context.getBean(StoredProcedureDao.class);
		
		List<TestModelForProcedure> dataList = (List<TestModelForProcedure>) storeProcedureDao
				.getDataByNativeQuery("20151226");
		logger.info("Got the data: {}", dataList);
		
		dataList = (List<TestModelForProcedure>) storeProcedureDao
				.getDataByNamedNativeQuery("20151226");
		logger.info("Got the data: {}", dataList);
		
		dataList = (List<TestModelForProcedure>) storeProcedureDao
				.getDataByDirectPureQuery("20151226");
		logger.info("Got the data: {}", dataList);
		
		List<TestModelWithoutColumnMapping> dataList2 = (List<TestModelWithoutColumnMapping>) storeProcedureDao
				.getTestTableDataByUsingScalerTypes("20151226");
		logger.info("Got the data: {}", dataList2);
		
		dataList2 = (List<TestModelWithoutColumnMapping>) storeProcedureDao
				.getTestTableDataByUsingScalerWithoutTypes("20151226");
		logger.info("Got the data: {}", dataList2);
				

		((AbstractApplicationContext) context).close();

	}

}
